package org.databene.dbsanity.model;

/**
 * Visitor interface for navigating CheckSuite hierarchies.
 * @since 1.0
 * @author Björn Kellermann
 * @author Volker Bergmann
 */
public interface SuiteVisitor {
	public void visit(SanityCheckFolder folder);
	public void visit(SanityCheckFile file);
	public void visit(SanityCheck check);
}
