/*
 * (c) Copyright 2010-2011 by Volker Bergmann. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, is permitted under the terms of the
 * GNU General Public License (GPL).
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * WITHOUT A WARRANTY OF ANY KIND. ALL EXPRESS OR IMPLIED CONDITIONS,
 * REPRESENTATIONS AND WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE
 * HEREBY EXCLUDED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

package org.databene.dbsanity.parser;

import org.databene.dbsanity.model.SanityCheckFile;
import org.databene.dbsanity.model.db.DbsPackage;
import org.w3c.dom.Element;

/**
 * Parses a &lt;table&gt; element in a DBSanity XML file.<br/><br/>
 * Created: 05.12.2010 13:24:24
 * @since 0.4
 * @author Volker Bergmann
 */
public class TableParser extends DbSanityXMLParser {

	public TableParser() {
		super("table", null, null, SanityCheckFile.class, DbsPackage.class);
	}

	@Override
	public Object parse(Element element, Object[] parentPath, DbSanityParseContext context) {
		throw new UnsupportedOperationException(getClass().getName() + ".parse() is not yet implemented");
		/*
		assertElementName("table", element);
		String tableName = parseRequiredName(element);
		DbsTable table = new DbsTable(tableName);
		Object parent = parent(parentPath);
		if (parent instanceof DbsPackage)
			((DbsPackage) parent).addTable(table);
		else {
			String parentName = getOptionalAttribute("parent", element);
			if (parentName != null) {
				DbsPackage parentPackage = context.getDbModel().getPackage(parentName);
				parentPackage.addTable(table);
			} else
				context.getDbModel().addTable(table);
		}
		
		// TODO v0.x parse keyGenerator?
		
	    table.setUnimportantColumns(parseUnimportantColumns(element));

		// parse child elements
		context.parseChildElementsOf(element, table, parentPath);
		return table;
		*/
    }
/*
	private static Set<String> parseUnimportantColumns(Element element) {
		HashSet<String> result = new HashSet<String>();
		String icSpec = element.getAttribute("irrelevant-columns");
		if (!StringUtil.isEmpty(icSpec)) {
			String[] tokens = StringUtil.tokenize(icSpec, ',');
			for (String token : tokens)
				result.add(token);
		}
		return result;
    }
*/
}
